import Head from 'next/head'
import Image from 'next/image'
import styles from '../styles/Home.module.css'
import {CreatePlayer, ListEvents} from "../helper/api";
import React from 'react';

export default function Home() {
    return (
        <div className={styles.container}>
            <Head>
                <title>Chess Royale</title>
                <meta name="description" content="Generated by create next app"/>
                <link rel="icon" href="/favicon.ico"/>
            </Head>

            <main className={styles.main}>
                <h1>
                    Chess Royale
                </h1>
                <div className={''}>
                    <h2 style={{'textAlign': 'center'}}>Join an Event</h2>
                    <StartForm/>
                </div>
            </main>


            <footer className={styles.footer}>
                <a
                    href="https://jacobbrazeal.com"
                    target="_blank" rel="noreferrer"
                >
                    By {' '}
                    Jacob Brazeal
                </a>
            </footer>
        </div>
    )
}

class StartForm extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            ready: false,
            events: [],
            playerName: '',
            playerEmail: '',
            eventId: null
        }
    }

    componentDidMount() {
        if (!this.state.ready) {
            this.fetchData()
        }
    }

    fetchData() {
        ListEvents().then(({events}) => {
            this.setState({
                ready: true,
                events: events,
                eventId: events[0].eventId
            })
        }).catch(e => {
            this.setState({
                error: true
            })
        });
    }

    async next() {
        // 1. Get a player ID
        const {playerId} = await CreatePlayer(this.state.eventId, this.state.playerName, this.state.playerEmail);
        // 2. Redirect to {eventId}/{playerId}
        window.location = `${this.state.eventId}/${playerId}/play`;
    }

    render() {
        if (this.state.error) {
            return 'There was an error. Try reloading the page'
        }
        if (!this.state.ready) {
            return 'Loading...'
        }
        if (!this.state.events.length) {
            return 'There are no events open at this time.'
        }

        return (<div>
                <div>
                    <label className={'flex'}>Your name*
                        <div className={'flex-space'}/>
                        <input type={'text'} onChange={({target}) => this.setState({playerName: target.value})}
                               value={this.state.playerName}/></label>
                </div>
                <div>
                    <label className={'flex'}>Your email*
                        <div className={'flex-space'}/>
                        <input type={'email'} onChange={({target}) => this.setState({playerEmail: target.value})}
                               value={this.state.playerEmail}/></label>
                </div>
                <div>
                    <label className={"flex"}>Event
                        <div className={"flex-space"}/>
                        <select onChange={({target}) => this.setState({eventId: target.value})}
                                value={this.state.eventId}>{
                            this.state.events.map(({eventId, eventName}) => (
                                <option key={eventId} value={eventId}>{eventName}</option>))
                        }</select></label></div>
                <div>
                    <em><small><p style={{width: '200px', textAlign: 'center', display: 'inline'}}>*Please enter your
                        full
                        legal name and email so that you are eligible for
                        prizes. <br/>By participating, you agree to be contacted by email in the future by me. <br/>You
                        also
                        assign me all rights to determine future prizes and prizewinners.
                    </p>
                    </small></em>
                </div>

                <div style={{marginTop: '20px'}}>
                    <button disabled={this.state.playerName.length < 5 || !this.state.playerEmail.includes('@')}
                            onClick={() => this.next()}>Next
                    </button>
                </div>
            </div>
        )
    }

}
